﻿using UnityEngine;
using System.Collections;
using UnityEngine.Events;

public class BossAI : MonoBehaviour {

    public com.geeitsomelaldy.platforming.DeathAndRespawnEvents Death;
    // Use this for initialization
    public float HP = 1;
    public Vector3 ProjectileAngle,RocketAngle;
    public Transform Phase1Source, Phase2Source, Phase3Source;
    public GameObject Phase1Projectile, Phase2Projectile, Phase3Projectile, Phase4Projectile;

    public bool isDying = false;
    public void Kill(bool Instant)
    {
        if (!Instant)
        {
            HP--;
            if (HP > 0)
            {
                StartCoroutine(OneFrameFlash());
                return;
            }
        }
        if (isDying) return;
        isDying = true;
        StopAllCoroutines();
        StartCoroutine(Death.Kill(this.gameObject, () =>
        {
            Destroy(this.gameObject);
        }));
    }
    public UnityEvent OnHitStart, OnHitEnd;
    private SpriteRenderer _spriter;
    private SpriteRenderer spriter
    {
        get
        {
            if (_spriter == null) _spriter = this.GetComponent<SpriteRenderer>();
                return _spriter;
        }
    }
    public Color FlashHitColour;
    public IEnumerator OneFrameFlash()
    {
        spriter.color = FlashHitColour;
        OnHitStart.Invoke();
        yield return new WaitForSeconds(0.1f);
        spriter.color = Color.white;
        OnHitEnd.Invoke();
        yield return new WaitForSeconds(0.1f);
        spriter.color = FlashHitColour;
        OnHitStart.Invoke();
        yield return new WaitForSeconds(0.1f);
        spriter.color = Color.white;
        OnHitEnd.Invoke();
    }

    public void OnTriggerEnter2D(Collider2D c)
    {
        if (c.tag == "playerAttack") Kill(false);
    }
    public Vector2 Speed = -Vector2.right;
    public float MoveFor = 5;
    public IEnumerator DoAI()
    {
        for (float t = 0; t < MoveFor; t += Time.deltaTime)
        {
            this.transform.Translate(Speed * Time.deltaTime);
            yield return null;
        }
        var animator = this.GetComponent<Animator>();
        animator.SetTrigger("Stopped");
        yield return new WaitForSeconds(Random.Range(0.2f, 1f));
        while (true)
        {
            int phase = Random.Range(0, 17);
            switch (phase)
            {
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                    Instantiate(Phase1Projectile, Phase1Source.position, Quaternion.Euler(ProjectileAngle));
                    animator.SetBool("Crouched", false);
                    break;
                case 6:
                case 7:
                case 8:

                    animator.SetBool("Crouched", false);
                    Instantiate(Phase2Projectile, Phase2Source.position, Quaternion.Euler(ProjectileAngle));
                    yield return new WaitForSeconds(0.6f);
                    Instantiate(Phase2Projectile, Phase2Source.position, Quaternion.Euler(ProjectileAngle));
                    yield return new WaitForSeconds(0.6f);
                    Instantiate(Phase2Projectile, Phase2Source.position, Quaternion.Euler(ProjectileAngle));
                    yield return new WaitForSeconds(1f);
                    break;
                case 9:
                case 10:
                case 11:

                    animator.SetBool("Crouched", false);
                    Instantiate(Phase4Projectile, Phase2Source.position, Quaternion.Euler(ProjectileAngle));
                    yield return new WaitForSeconds(0.2f);
                    Instantiate(Phase4Projectile, Phase2Source.position, Quaternion.Euler(ProjectileAngle));
                    yield return new WaitForSeconds(0.2f);
                    Instantiate(Phase4Projectile, Phase2Source.position, Quaternion.Euler(ProjectileAngle));
                    yield return new WaitForSeconds(1f);
                    break;
                case 12:
                case 13:
                case 14:
                case 15:
                case 16:
                case 17:
                    Instantiate(Phase3Projectile, Phase3Source.position, Quaternion.Euler(ProjectileAngle));
                    animator.SetBool("Crouched", true);
                    yield return new WaitForSeconds(0.3f);
                    animator.SetBool("Crouched", false);
                    break;
            }
            yield return new WaitForSeconds(Random.Range(1, 3));
        }
    }
    public void OnEnable()
    {
        StartCoroutine(DoAI());
    }
    void OnDrawGizmos()
    {
        Gizmos.DrawLine(this.transform.position, this.transform.position + Quaternion.Euler(ProjectileAngle) * Vector3.forward);

        Gizmos.DrawLine(Phase2Source.position, Phase2Source.position + Quaternion.Euler(RocketAngle) * Vector3.forward);
    }
}
