﻿using UnityEngine;
using System.Collections;
using com.geeitsomelaldy.platforming;

public class CannonballEnemy : MonoBehaviour, IEnemy {
    public int Damage;
    public float Speed = 1;
    public float Life = 2;
    public bool UseDeathOnTimeout = true;
    public DeathAndRespawnEvents Death;
    public Vector3 dir;
    public float rotSpeed = 1;
    public bool Homing = false;
    public Transform HomingTarget;
	// Use this for initialization
	void Start () {
        if(dir.magnitude == 0) dir =  this.transform.forward;
        this.transform.rotation = Quaternion.identity;
        if (Homing)
        {
            HomingTarget = GameObject.FindGameObjectWithTag("Player").transform;
        }
	}
	
	// Update is called once per frame
	void Update () {
        if (Life <= 0) return;
        if (Homing)
        {
            var q = this.transform.rotation;
            this.transform.LookAt(HomingTarget);
            this.transform.rotation = Quaternion.RotateTowards(q, this.transform.rotation, Time.deltaTime * rotSpeed);
            this.transform.Translate(Vector3.forward * Speed * Time.deltaTime, Space.Self);
        }
        else
        {
            this.transform.Translate(dir * Speed * Time.deltaTime);
        }
        Life -= Time.deltaTime;
        if (Life < 0)
        {
            if (UseDeathOnTimeout)
            {
                Kill();
            }
            else
            {
                Destroy(this.gameObject);
            }
        }
	}
    void Kill()
    {
        StartCoroutine(Death.Kill(this.gameObject, () =>
        {
            Destroy(this.gameObject);
        }));
    }

    public bool AttackFrom(Vector2 position, Vector2 velocity, DamageType damageType)
    {
        Kill();
        return false;
    }

    public int DamageDealt()
    {
        return Damage;
    }

}
