﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic; 

public class ChildActivator : MonoBehaviour {
    public float EnableAfter = 1;
	// Use this for initialization
    public List<GameObject> Items;
	void OnEnable () {
        Invoke("Activate", EnableAfter);
        if (Items == null || Items.Count == 0)
        {
            Items = new List<GameObject>();
            for (int i = 0; i < this.transform.childCount; i++)
            {
                Items.Add(this.transform.GetChild(i).gameObject);
            }
        }
        Items.ForEach((x) => { x.SetActive(false); });
	}
    void Activate()
    {
        if (this.gameObject.activeInHierarchy)
        {
            Items.ForEach((x) => { x.SetActive(true); });
        }

    }
	// Update is called once per frame
	void Update () {
	
	}
}
