﻿using UnityEngine;
using System.Collections;
using UnityEngine.Events; 

public class WanderingAI : MonoBehaviour  {
    
    public com.geeitsomelaldy.platforming.DeathAndRespawnEvents Death;
    public bool isDead = false;
    public float MinX = 0;
    public float MaxX = 0;
    public float Speed = 2;
    public float HP = 2;
    public UnityEvent OnHitStart, OnHitEnd;
    public void Kill()
    {
        HP--;
        StartCoroutine(OneFrameFlash());
        if (HP > 0) return;
        if (isDead) return;
        isDead = true;
        StopAllCoroutines();
        StartCoroutine(Death.Kill(this.gameObject, () =>
        {
            Destroy(this.gameObject);
        }));
    }
    public IEnumerator OneFrameFlash()
    {
        OnHitStart.Invoke();
        yield return new WaitForSeconds(0.1f) ;
        OnHitEnd.Invoke();
    }
    public void Start()
    {
        StartCoroutine(Walk());
    }
    public IEnumerator Walk()
    {
        int direction = 1;
        float x = 0;
        float deltaX = 0;
        Vector3 initialPosition = this.transform.position;
        while (true)
        {
            yield return null;
            deltaX = Speed * Time.deltaTime * direction;
            x += deltaX;
            if(x > MaxX) { 
                direction = -1;
                x = MaxX;
            }
            if(x < MinX) {
                direction = 1;
                x = MinX;
            }
            this.transform.position = initialPosition + new Vector3(x, 0, 0);
            
        }
    }
}
