﻿using UnityEngine;
using System.Collections;
using com.geeitsomelaldy.platforming;

public class HomingMissileEnemy : MonoBehaviour, IEnemy
{
    public int Damage;
    public float Speed = 1;
    public float Life = 10;
    public float HomeAfter = 3;
    public float HomeFor = 4;
    public bool UseDeathOnTimeout = true;
    public DeathAndRespawnEvents Death;
    public Vector3 dir;
    public Vector3 OffsetTarget;
    public float rotSpeed = 1; 
    public Transform HomingTarget;
	// Use this for initialization
	void Start () {
        this.transform.rotation = Quaternion.Euler(dir);
            HomingTarget = GameObject.FindGameObjectWithTag("Player").transform; 
	}
	
	// Update is called once per frame
	void Update () {
        if (Life <= 0) return;
        if (HomeAfter > 0) HomeAfter -= Time.deltaTime;
        if (HomeAfter <= 0 && HomeFor >= 0)
        {
            var q = this.transform.rotation;
            this.transform.LookAt(HomingTarget.position + OffsetTarget);
            this.transform.rotation = Quaternion.RotateTowards(q, this.transform.rotation, Time.deltaTime * rotSpeed);
            HomeFor -= Time.deltaTime;
        }
        this.transform.Translate(Vector3.forward * Speed * Time.deltaTime, Space.Self);
        
        Life -= Time.deltaTime;
        if (Life < 0)
        {
            if (UseDeathOnTimeout)
            {
                Kill();
            }
            else
            {
                Destroy(this.gameObject);
            }
        }
	}
    void Kill()
    {
        StartCoroutine(Death.Kill(this.gameObject, () =>
        {
            Destroy(this.gameObject);
        }));
    }

    public bool AttackFrom(Vector2 position, Vector2 velocity, DamageType damageType)
    {
        Kill();
        return false;
    }

    public int DamageDealt()
    {
        return Damage;
    }

}
