﻿using UnityEngine;
using System.Collections;
using UnityEngine.Events;

public class PlaneAI : MonoBehaviour {

    public com.geeitsomelaldy.platforming.DeathAndRespawnEvents Death;
	// Use this for initialization
    public float HP = 1;
    public GameObject ProjectilePrefab;
    public Vector3 ProjectileAngle;
    public float ReloadTime = 3;
    public float ProjectileNumber = 3;
    public float ProjectileDelay = 0.2f;
    public bool isDying = false;
    public void Kill(bool Instant)
    {
        if (!Instant)
        {
            HP--;
            if (HP > 0)
            {
                StartCoroutine(OneFrameFlash());
                return;
            }
        }
        if (isDying) return;
        isDying = true;
        StopAllCoroutines();
        StartCoroutine(Death.Kill(this.gameObject, () =>
        {
            Destroy(this.gameObject);
        }));
    }
    public UnityEvent OnHitStart, OnHitEnd;
    public IEnumerator OneFrameFlash()
    {
        OnHitStart.Invoke();
        yield return new WaitForSeconds(0.1f);
        OnHitEnd.Invoke();
        yield return new WaitForSeconds(0.1f);
        OnHitStart.Invoke();
        yield return new WaitForSeconds(0.1f);
        OnHitEnd.Invoke();
    }
        
    public void OnTriggerEnter2D(Collider2D c)
    {
        Debug.Log("START COLLISION" + c.name);
        if (c.tag == "playerAttack") Kill(false);
    }
    public Vector2 Speed = - Vector2.right;
    public float MoveFor = 5;
    public IEnumerator DoAI()
    {         
        while (true)
        {
            for (var i = 0; i < ProjectileNumber; i++)
            {
                yield return new WaitForSeconds(ProjectileDelay);
                var projectile = (GameObject)Instantiate(ProjectilePrefab, this.transform.position, Quaternion.Euler(ProjectileAngle));
               
            }
            yield return new WaitForSeconds(ReloadTime);
        }
    }
    public void OnEnable()
    {
        StartCoroutine(DoAI());
    }
    void OnDrawGizmos()
    {
        Gizmos.DrawLine(this.transform.position, this.transform.position + Quaternion.Euler(ProjectileAngle) * Vector3.forward);
    }
}
