﻿using UnityEngine;
using System.Collections;
using com.geeitsomelaldy.platforming;

    [RequireComponent(typeof(com.geeitsomelaldy.platforming.PlayerPlatformController))]
public class PlayerAttack : MonoBehaviour {
    public GameObject StandingAttack;
    public GameObject DuckingAttack;
    public GameObject ProjectilePrefab;
    public float AttackFor = 0.25f;
    public float Cooldown = 0.5f;
    public string AnimatorAttacking = "IsAttacking";
    public string FireButton = "Fire 1";
    private PlatformerMecanimAnimator _animator;
    private PlatformerMecanimAnimator anim
    {
        get
        {
            if (_animator == null) _animator = this.GetComponent<PlatformerMecanimAnimator>();
            return _animator;
        }
    }
    private PlayerInput _input;
    private PlayerInput input
    {
        get
        {
            if(_input == null) _input = this.GetComponent<PlayerInput>();
            return _input;
        }
    }
    private PlayerPlatformController _platformController;
    private PlayerPlatformController platformController
    {
        get
        {
            if (_platformController == null) _platformController = this.GetComponent<PlayerPlatformController>();
            return _platformController;
        }
    }
	// Use this for initialization
	void Start () {
        StandingAttack.SetActive(false);
        DuckingAttack.SetActive(false);
	}
	
	// Update is called once per frame
	void Update () {
        if (!isAttacking && Input.GetButtonDown(FireButton))
        {
            if (input.isCrouched)
            {
                StartCoroutine(DoAttack(DuckingAttack, AttackFor));
            }
            else
            {
                StartCoroutine(DoAttack(StandingAttack, AttackFor));

            }
        }
	}
    bool isAttacking = false;
    public IEnumerator DoAttack(GameObject item, float time)
    {
        if (!isAttacking)
        {
            item.SetActive(true);
            var attack = (GameObject)Instantiate(ProjectilePrefab, item.transform.position, item.transform.rotation);
            //attack.transform.parent = item.transform;
            if (platformController.Direction == -1)
            {
                attack.transform.eulerAngles = new Vector3(
                    attack.transform.eulerAngles.x,
                    attack.transform.eulerAngles.y + 180,
                    attack.transform.eulerAngles.z);
            }
            isAttacking = true;
            anim.Animator.SetBool(AnimatorAttacking, true);
            yield return new WaitForSeconds(time);
            item.SetActive(false);
            anim.Animator.SetBool(AnimatorAttacking, false);
            yield return new WaitForSeconds(Cooldown);
            isAttacking = false;
        }
    }
}
