﻿using UnityEngine;
using System.Collections;
using com.geeitsomelaldy.platforming;
using UnityEngine.Events;

public class SoRFollow : MonoBehaviour {
    public Transform[] Screens;
    public Transform Player;
    public GameObject GO;
    public PlayerHealth PlayerHealth;
    public int ScreenID = 0;
	// Use this for initialization
	void Start () {
        foreach (var n in Screens)
        {
            n.gameObject.SetActive(false);
        }
        FollowMode = true;
        OnStart.Invoke();
	}
    public bool FollowMode;
    public float ScreenX
    {
        get
        {
            if (FollowMode)
            {
                return Mathf.Min(
                    Screens[ScreenID].position.x,
                    Mathf.Max(Screens[ScreenID > 0?ScreenID - 1:0].position.x, Player.transform.position.x)
                    );
            }
            else
            {
                return Screens[ScreenID].position.x;
            }
        }
    }
    public void ScreenComplete()
    {
        ScreenID++;
        FollowMode = true;
        GO.SetActive(true);
    }
    bool isEnding;
    public UnityEvent OnEnd, OnSecondLastScreenStart, OnLastScreenStart,OnStart;
    void End() {
        OnEnd.Invoke();
    }
    private bool onSecondLastScreen;
    private bool onLastScreen;
	// Update is called once per frame
    void Update()
    {
        if (!onSecondLastScreen && ScreenID == Screens.Length - 2 && !FollowMode)
        {
            Debug.LogWarning("2nd LAST SCREEN!");
            onSecondLastScreen = true;
            OnSecondLastScreenStart.Invoke();
        }
        if (!onLastScreen && ScreenID == Screens.Length - 1 )
        {
            Debug.LogWarning("LAST SCREEN!");
            onLastScreen = true;
            OnLastScreenStart.Invoke();
        }
        if (ScreenID >= Screens.Length)
        {
            if (!isEnding)
            {
                FollowMode = false;
                GO.SetActive(false);
                Invoke("End", 4);
                isEnding = true;
            }
            return;
        }
        var target = new Vector3(
            ScreenX,
            this.transform.position.y,
            this.transform.position.z);
        if (ScreenX >= Screens[ScreenID].position.x)
        {
            if (FollowMode == true)
            {
                //this.transform.position = target;
                Screens[ScreenID].gameObject.SetActive(true);
                GO.SetActive(false);
                FollowMode = false;
                PlayerHealth.RespawnPoint.x = ScreenX;
            }
        } 
            
        this.transform.position = Vector3.Lerp(this.transform.position, target, 0.1f);
        
	}
}
