﻿using UnityEngine;
using System.Collections;
using UnityEngine.Events;

namespace com.geeitsomelaldy.platforming
{ 
    public class BasicPickup : MonoBehaviour, IPickup
    {
        public AudioClip PlayOnPickup;
        public bool RespawnEnabled = false;
        public com.geeitsomelaldy.platforming.DeathAndRespawnEvents OnPickup;
        public void PickedUp()
        {
            if (PlayOnPickup != null) AudioSource.PlayClipAtPoint(PlayOnPickup, this.transform.position);
            if (RespawnEnabled)
            {
                StartCoroutine(OnPickup.Respawn(this.gameObject, this.transform.position, null));
            }
            else
            {
                StartCoroutine(OnPickup.Kill(this.gameObject, null));
            }
            
        }
    }

}