﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;
using UnityEngine.Events;

namespace com.geeitsomelaldy.platforming
{
    [System.Serializable]
    public class DeathAndRespawnEvents
    {
        public GameObject CreateOnDeath;
        public float DeathAnimationTime;
        public GameObject CreateOnRespawn;
        public float RespawnAnimationTime;
        public UnityEvent OnBeginDeath, OnEndDeath, OnBeginRespawn, OnEndRespawn;
        public IEnumerator Respawn(GameObject actor, Vector2 RespawnPoint, System.Action OnComplete)
        { 
            OnBeginDeath.Invoke();
            if (this.CreateOnDeath != null) GameObject.Instantiate(this.CreateOnDeath, actor.transform.position, Quaternion.identity);
            yield return new WaitForSeconds(DeathAnimationTime);
            OnEndDeath.Invoke();
            actor.transform.position = RespawnPoint;
            if (this.CreateOnDeath != null) GameObject.Instantiate(this.CreateOnRespawn, actor.transform.position, Quaternion.identity);
            OnBeginRespawn.Invoke();
            yield return new WaitForSeconds(RespawnAnimationTime);
            OnEndRespawn.Invoke(); 
            if (OnComplete != null)
            {
                OnComplete.Invoke();
            }
        }

        public IEnumerator Kill(GameObject actor, System.Action OnComplete)
        {
            OnBeginDeath.Invoke();
            if (this.CreateOnDeath != null) GameObject.Instantiate(this.CreateOnDeath, actor.transform.position, Quaternion.identity);
            yield return new WaitForSeconds(DeathAnimationTime);
            OnEndDeath.Invoke();
            if (OnComplete != null)
            {
                OnComplete.Invoke();
            }
        }
    }
}
