﻿using UnityEngine;
using System.Collections;

namespace com.geeitsomelaldy.platforming
{
    [RequireComponent(typeof(BaseCollider))]
    public class PlayerPickup : MonoBehaviour
    {

        [Tooltip("The layers that contain pickups")]
        public LayerMask PickupLayers;
        private BaseCollider _bc;
        private BaseCollider baseCollider
        {
            get
            {
                if (_bc == null)
                {
                    _bc = this.GetComponent<BaseCollider>();
                }
                return _bc;
            }
        } 

        // Update is called once per frame
        void Update()
        {
            if (baseCollider.HasHit(PickupLayers))
            {
                var ipickup = baseCollider.hit.collider.GetComponent<IPickup>();
                if (ipickup != null) ipickup.PickedUp();
            }
        }
    }
}
