﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;
using UnityEngine.Events;

namespace com.geeitsomelaldy.platforming
{
    public class StompableEnemy:MonoBehaviour, IEnemy
    {
        public int DealDamage = 1;
        public UnityEvent OnHit;
        private BoxCollider2D _collider;
        public void Start()
        {
            _collider = this.GetComponent<BoxCollider2D>();
        }
        public bool AttackFrom(Vector2 position, Vector2 velocity, DamageType damageType)
        {
            if (canBeAttackedFrom(position, velocity,damageType))
            {
                OnHit.Invoke();
                return true;
            }
            return false;
        }
        private bool canBeAttackedFrom(Vector2 position, Vector2 velocity, DamageType damageType)
        {
            if (damageType != DamageType.Stomp) return true; //can be attacked from anywhere with non-stomp type attack
            if (velocity.y >= 0) return false;
            if (_collider)
            { 
                return position.y > _collider.bounds.min.y;
            }
            return position.y > this.transform.position.y; //can be attacked from above only
        }


        public int DamageDealt()
        {
            return DealDamage;
        }
    }
}
